import time
from random import randint

def fullNeighborhood(S, SBenefit, SWeight, objects, capacity):
    V = []
    Vbenefit = []
    Vweight = []
    for i in range(len(objects)):
        for j in range(i + 1, len(objects)):
            SCand = S.copy()
            SCandWeight = SWeight
            SCandBenefit = SBenefit
            #Switch i bit
            if(SCand[i] == 1):
                SCand[i] = 0
                SCandWeight -= objects[i].weight
                SCandBenefit -= objects[i].benefit
            else:
                SCand[i] = 1
                SCandWeight += objects[i].weight
                SCandBenefit += objects[i].benefit
            #Switch j bit
            if(SCand[j] == 1):
                SCand[j] = 0
                SCandWeight -= objects[j].weight
                SCandBenefit -= objects[j].benefit
            else:
                SCand[j] = 1
                SCandWeight += objects[j].weight
                SCandBenefit += objects[j].benefit
            if(SCandBenefit > SBenefit and SCandWeight <= capacity):
                #Neighbor is better and feasible
                V.append(SCand)
                Vbenefit.append(SCandBenefit)
                Vweight.append(SCandWeight)
    print(str(Vbenefit))
    input("Type anything to continue...")
    return V, Vbenefit, Vweight

def firstImprovementNeighborhood(S, SBenefit, SWeight, objects, capacity):
    V = []
    Vbenefit = []
    Vweight = []
    for i in range(len(objects)):
        for j in range(i + 1, len(objects)):
            SCand = S.copy()
            SCandWeight = SWeight
            SCandBenefit = SBenefit
            #Switch i bit
            if(SCand[i] == 1):
                SCand[i] = 0
                SCandWeight -= objects[i].weight
                SCandBenefit -= objects[i].benefit
            else:
                SCand[i] = 1
                SCandWeight += objects[i].weight
                SCandBenefit += objects[i].benefit
            #Switch j bit
            if(SCand[j] == 1):
                SCand[j] = 0
                SCandWeight -= objects[j].weight
                SCandBenefit -= objects[j].benefit
            else:
                SCand[j] = 1
                SCandWeight += objects[j].weight
                SCandBenefit += objects[j].benefit
            if(SCandBenefit > SBenefit and SCandWeight <= capacity):
                #Neighbor is better and feasible
                V.append(SCand)
                Vbenefit.append(SCandBenefit)
                Vweight.append(SCandWeight)
                print(str(Vbenefit))
                return V, Vbenefit, Vweight
    return V, Vbenefit, Vweight

def ThreeBitNeighborhood(S, SBenefit, SWeight, objects, capacity):
    V = []
    Vbenefit = []
    Vweight = []
    for i in range(len(objects)):
        for j in range(i + 1, len(objects)):
            for k in range(j + 1, len(objects)):
                SCand = S.copy()
                SCandWeight = SWeight
                SCandBenefit = SBenefit
                #Switch i bit
                if(SCand[i] == 1):
                    SCand[i] = 0
                    SCandWeight -= objects[i].weight
                    SCandBenefit -= objects[i].benefit
                else:
                    SCand[i] = 1
                    SCandWeight += objects[i].weight
                    SCandBenefit += objects[i].benefit
                #Switch j bit
                if(SCand[j] == 1):
                    SCand[j] = 0
                    SCandWeight -= objects[j].weight
                    SCandBenefit -= objects[j].benefit
                else:
                    SCand[j] = 1
                    SCandWeight += objects[j].weight
                    SCandBenefit += objects[j].benefit
                #Switch k bit
                if(SCand[k] == 1):
                    SCand[k] = 0
                    SCandWeight -= objects[k].weight
                    SCandBenefit -= objects[k].benefit
                else:
                    SCand[k] = 1
                    SCandWeight += objects[k].weight
                    SCandBenefit += objects[k].benefit
                if(SCandBenefit > SBenefit and SCandWeight <= capacity):
                    #Neighbor is better and feasible
                    V.append(SCand)
                    Vbenefit.append(SCandBenefit)
                    Vweight.append(SCandWeight)
                    #print(str(Vbenefit))
                    return V, Vbenefit, Vweight
    return V, Vbenefit, Vweight

def FourBitNeighborhood(S, SBenefit, SWeight, objects, capacity):
    V = []
    Vbenefit = []
    Vweight = []
    for i in range(len(objects)):
        for j in range(i + 1, len(objects)):
            for k in range(j + 1, len(objects)):
                for l in range(k + 1, len(objects)):
                    SCand = S.copy()
                    SCandWeight = SWeight
                    SCandBenefit = SBenefit
                    #Switch i bit
                    if(SCand[i] == 1):
                        SCand[i] = 0
                        SCandWeight -= objects[i].weight
                        SCandBenefit -= objects[i].benefit
                    else:
                        SCand[i] = 1
                        SCandWeight += objects[i].weight
                        SCandBenefit += objects[i].benefit
                    #Switch j bit
                    if(SCand[j] == 1):
                        SCand[j] = 0
                        SCandWeight -= objects[j].weight
                        SCandBenefit -= objects[j].benefit
                    else:
                        SCand[j] = 1
                        SCandWeight += objects[j].weight
                        SCandBenefit += objects[j].benefit
                    #Switch k bit
                    if(SCand[k] == 1):
                        SCand[k] = 0
                        SCandWeight -= objects[k].weight
                        SCandBenefit -= objects[k].benefit
                    else:
                        SCand[k] = 1
                        SCandWeight += objects[k].weight
                        SCandBenefit += objects[k].benefit
                    #Switch l bit
                    if(SCand[l] == 1):
                        SCand[l] = 0
                        SCandWeight -= objects[l].weight
                        SCandBenefit -= objects[l].benefit
                    else:
                        SCand[l] = 1
                        SCandWeight += objects[l].weight
                        SCandBenefit += objects[l].benefit
                    if(SCandBenefit > SBenefit and SCandWeight <= capacity):
                        #Neighbor is better and feasible
                        V.append(SCand)
                        Vbenefit.append(SCandBenefit)
                        Vweight.append(SCandWeight)
                        #print(str(Vbenefit))
                        return V, Vbenefit, Vweight
    return V, Vbenefit, Vweight

def firstImprovementNeighborhoodFull(S, SBenefit, SWeight, objects, capacity):
    V = []
    Vbenefit = []
    Vweight = []
    for i in range(len(objects)):
        for j in range(i + 1, len(objects)):
            SCand = S.copy()
            SCandWeight = SWeight
            SCandBenefit = SBenefit
            #Switch i bit
            if(SCand[i] == 1):
                SCand[i] = 0
            else:
                SCand[i] = 1
            #Switch j bit
            if(SCand[j] == 1):
                SCand[j] = 0
            else:
                SCand[j] = 1
            [SCandBenefit, SCandWeight] = fullObjEvaluation(SCand, objects)
            if(SCandBenefit > SBenefit and SCandWeight <= capacity):
                #Neighbor is better and feasible
                V.append(SCand)
                Vbenefit.append(SCandBenefit)
                Vweight.append(SCandWeight)
                print(str(Vbenefit))
                return V, Vbenefit, Vweight
    return V, Vbenefit, Vweight

def tabuSearchNeighborhood(S, SBenefit, SWeight, objects, capacity, T, SBestBenefit):
    SCandBest = []
    SCandBestBenefit = 0
    SCandBestWeight = 0
    bestI = 0
    bestJ = 0
    for i in range(len(objects)):
        for j in range(i + 1, len(objects)):
            SCand = S.copy()
            SCandWeight = SWeight
            SCandBenefit = SBenefit
            #Switch i bit
            if(SCand[i] == 1):
                SCand[i] = 0
                SCandWeight -= objects[i].weight
                SCandBenefit -= objects[i].benefit
            else:
                SCand[i] = 1
                SCandWeight += objects[i].weight
                SCandBenefit += objects[i].benefit
            #Switch j bit
            if(SCand[j] == 1):
                SCand[j] = 0
                SCandWeight -= objects[j].weight
                SCandBenefit -= objects[j].benefit
            else:
                SCand[j] = 1
                SCandWeight += objects[j].weight
                SCandBenefit += objects[j].benefit
            if((SCandBenefit > SCandBestBenefit and SCandWeight <= capacity) and (([i, j] not in T) or SCandBenefit > SBestBenefit)):
                #Neighbor is currently the best and feasible and not tabu or better than the best solution
                SCandBest = SCand.copy()
                SCandBestBenefit = SCandBenefit
                SCandBestWeight = SCandWeight
                bestI = i
                bestJ = j
    return SCandBest, SCandBestBenefit, SCandBestWeight, bestI, bestJ


def fullObjEvaluation(S, objects):
    benefit = 0
    weight = 0
    for i in range(len(S)):
        if(S[i] == 1):
            benefit += objects[i].benefit
            weight += objects[i].weight
    return [benefit, weight]

def ascendentMethod(S, SBenefit, SWeight, objects, capacity):
    [V, Vbenefit, Vweight] = fullNeighborhood(S, SBenefit, SWeight, objects, capacity)
    while(len(V) > 0):
        bestBenefit = -1
        bestWeight = 99999999
        iBest = -1
        for i in range(0, len(Vbenefit)):
            if(Vbenefit[i] > bestBenefit or (Vbenefit[i] == bestBenefit and Vweight < bestWeight)):
                bestBenefit = Vbenefit[i]
                bestWeight = Vweight
                iBest = i
        S = V[iBest].copy()
        SWeight = Vweight[iBest]
        SBenefit = Vbenefit[iBest]
        [V, Vbenefit, Vweight] = fullNeighborhood(S, SBenefit, SWeight, objects, capacity)
    return S, SBenefit, SWeight


def firstImprovementAscendentMethod(S, SBenefit, SWeight, objects, capacity):
    [V, Vbenefit, Vweight] = firstImprovementNeighborhood(S, SBenefit, SWeight, objects, capacity)
    while(len(V) > 0):
        S = V[0].copy()
        SWeight = Vweight[0]
        SBenefit = Vbenefit[0]
        [V, Vbenefit, Vweight] = firstImprovementNeighborhood(S, SBenefit, SWeight, objects, capacity)
    return S, SBenefit, SWeight

def randomAscendentMethod(S, SBenefit, SWeight, objects, capacity, nItersRefinement, timeLimitRefinement):
    iter = 0
    startTime = time.time()
    while(iter < nItersRefinement and time.time() - startTime < timeLimitRefinement):
        ++iter
        i = randint(0, len(objects) - 1)
        j = randint(0, len(objects) - 1)
        SCand = S.copy()
        SCandWeight = SWeight
        SCandBenefit = SBenefit
        #Switch i bit
        if(SCand[i] == 1):
            SCand[i] = 0
            SCandWeight -= objects[i].weight
            SCandBenefit -= objects[i].benefit
        else:
            SCand[i] = 1
            SCandWeight += objects[i].weight
            SCandBenefit += objects[i].benefit
        #Switch j bit
        if(SCand[j] == 1):
            SCand[j] = 0
            SCandWeight -= objects[j].weight
            SCandBenefit -= objects[j].benefit
        else:
            SCand[j] = 1
            SCandWeight += objects[j].weight
            SCandBenefit += objects[j].benefit
        if(SCandBenefit > SBenefit and SCandWeight <= capacity):
            #Neighbor is better and feasible
            S = SCand.copy()
            SBenefit = SCandBenefit
            SWeight = SCandWeight
            iter = 0
            print(SBenefit)
    return S, SBenefit, SWeight

def randomNotDescendentMethod(S, SBenefit, SWeight, objects, capacity, nItersRefinement, timeLimitRefinement):
    iter = 0
    startTime = time.time()
    while(iter < nItersRefinement and time.time() - startTime < timeLimitRefinement):
        ++iter
        i = randint(0, len(objects) - 1)
        j = randint(0, len(objects) - 1)
        SCand = S.copy()
        SCandWeight = SWeight
        SCandBenefit = SBenefit
        #Switch i bit
        if(SCand[i] == 1):
            SCand[i] = 0
            SCandWeight -= objects[i].weight
            SCandBenefit -= objects[i].benefit
        else:
            SCand[i] = 1
            SCandWeight += objects[i].weight
            SCandBenefit += objects[i].benefit
        #Switch j bit
        if(SCand[j] == 1):
            SCand[j] = 0
            SCandWeight -= objects[j].weight
            SCandBenefit -= objects[j].benefit
        else:
            SCand[j] = 1
            SCandWeight += objects[j].weight
            SCandBenefit += objects[j].benefit
        if(SCandBenefit >= SBenefit and SCandWeight <= capacity):
            #Neighbor not worse and feasible
            if(SCandBenefit > SBenefit):
                iter = 0
            S = SCand.copy()
            SBenefit = SCandBenefit
            SWeight = SCandWeight
            print(SBenefit)
    return S, SBenefit, SWeight
