import constructive
import refinement
import metaheuristics

#Program parameters
fileName = "Instances/cv10.txt"
constructiveHeuristic = 2

#File reading
file = open(fileName)
n = int(file.readline())
costs = []
for line in file:
    line = line.split(" ")
    lineInt = []
    for i in line:
        lineInt.append(int(i))
    costs.append(lineInt)
print(costs)

s = []
fs = 0
#Nearest Neighbor
if(constructiveHeuristic == 1):
    s = [0]
    currentCity = 0
    for i in range(n - 1):
        min = 999999
        minJ = -1
        for j in range(len(costs[currentCity])):
            if(j not in s and min >= costs[currentCity][j]):
                min = costs[currentCity][j]
                minJ = j
        s = s + [minJ]
        fs += costs[currentCity][minJ]
        currentCity = minJ
    fs += costs[s[-1]][s[0]]
    print(s)
    print(fs)
elif(constructiveHeuristic == 2):
    s = [0, 1, 2]
    fs = costs[0][1] + costs[1][2] 
    notInS = [3, 4, 5, 6, 7, 8, 9]
    for l in range(len(notInS)): 
        sCand = s[:]
        fsCand = fs
        bestI = -1
        bestJ = -1
        bestK = -1
        bestInsertion = 999999
        for i in range(len(s) - 1):
            j = i + 1
            #for j in range(i + 1, len(s)):
            #    if(i != j):
            for k in range(len(notInS)):
                costInsertion = costs[s[i]][notInS[k]] + costs[notInS[k]][s[j]] - costs[s[i]][s[j]]
                print(s[i], s[j], notInS[k], costInsertion)
                if(costInsertion <= bestInsertion):
                    sCand = s[0:i+1] + [notInS[k]] + s[j:]
                    fsCand = fs + costInsertion
                    #print(fsCand)
                    bestInsertion = costInsertion
                    bestI = i
                    bestJ = j
                    bestK = k
        print(bestI)
        print(bestJ)
        print(bestK)
        print(sCand)
        s = sCand[:]
        fs = fsCand
        notInS.pop(bestK)
        print(notInS)
        print(fs)
        input("Type to continue...")
    fs = fs + costs[s[-1]][s[0]]
    print(s)
    print(fs)

#print("Objects sorted by benefit / weight: ")
#for obj in objectsSorted:
#    print(obj)

##alpha = 0.01
##refinementHeuristic = 8
##nItersRefinement = 10000
##timeLimitRefinement = 60000
##nItersMH = 300
##timeLimitMH = 60
##BTmax = 100
##Tsize = 5
##SAalpha = 0.8
##k = 10
##SAmax = k * numObjects
##T0 = 500
##
##print("\nSolving...")
##
###Constructive heuristic
##if(constructiveHeuristic == 1):
##    [S, SBenefit, SWeight] = constructive.greedyHeuristic(objects, capacity)
##elif(constructiveHeuristic == 2):
##    [S, SBenefit, SWeight] = constructive.partiallyGreedyHeuristic(objects, capacity, alpha)
##
##print("\nS = " + str(S))
##print("Weight = " + str(SWeight))
##print("Benefit = " + str(SBenefit))    
##    
###Refinement Heuristic
##if(refinementHeuristic == 1):
##    [S, SBenefit, SWeight] = refinement.ascendentMethod(S, SBenefit, SWeight, objects, capacity)
##elif(refinementHeuristic == 2):
##    [S, SBenefit, SWeight] = refinement.firstImprovementAscendentMethod(S, SBenefit, SWeight, objects, capacity)
##elif(refinementHeuristic == 3):
##    [S, SBenefit, SWeight] = refinement.randomAscendentMethod(S, SBenefit, SWeight, objects, capacity, nItersRefinement, timeLimitRefinement)
##elif(refinementHeuristic == 4):
##    [S, SBenefit, SWeight] = refinement.randomNotDescendentMethod(S, SBenefit, SWeight, objects, capacity, nItersRefinement, timeLimitRefinement)
##elif(refinementHeuristic == 5):
##    [S, SBenefit, SWeight] = metaheuristics.multiStart(objects, capacity, nItersMH, timeLimitMH)
##elif(refinementHeuristic == 6):
##    [S, SBenefit, SWeight] = metaheuristics.grasp(objects, capacity, alpha, nItersMH, timeLimitMH)
##elif(refinementHeuristic == 7):
##    [S, SBenefit, SWeight] = constructive.greedyHeuristic(objects, capacity)
##    [S, SBenefit, SWeight] = metaheuristics.tabuSearch(S, SBenefit, SWeight, objects, capacity, BTmax, Tsize)
##elif(refinementHeuristic == 8):
##    [S, SBenefit, SWeight] = constructive.greedyHeuristic(objects, capacity)
##    [S, SBenefit, SWeight] = metaheuristics.simulatedAnnealing(S, SBenefit, SWeight, objects, capacity, SAalpha, SAmax, T0)
##        
###Writing output
##print("\nS = " + str(S))
##print("Weight = " + str(SWeight))
##print("Benefit = " + str(SBenefit))
##file = open(fileName + ".sol", "w")
##file.write(str(SBenefit) + "\n")
##for s in S:
##    file.write(str(s) + " ")
##file.close()

